Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1467003 - Review Request: libgpiod - C library and tools for interacting with linux GPIO char device
Summary: Review Request: libgpiod - C library and tools for interacting with linux GPI...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Vitaly
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: IoT
TreeView+ depends on / blocked
 
Reported: 2017-07-01 12:48 UTC by Peter Robinson
Modified: 2017-08-31 14:13 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-08-31 14:13:29 UTC
Type: Bug
Embargoed:
vitaly: fedora-review+


Attachments (Terms of Use)

Description Peter Robinson 2017-07-01 12:48:45 UTC
SPEC: https://pbrobinson.fedorapeople.org/libgpiod.spec
SRPM: https://pbrobinson.fedorapeople.org/libgpiod-0.3-1.fc26.src.rpm

Description:
libgpiod is a C library and tools for interacting with the linux GPIO character 
device (gpiod stands for GPIO device) The new character device interface 
guarantees all allocated resources are freed after closing the device file 
descriptor and adds several new features that are not present in the obsolete 
sysfs interface (like event polling, setting/reading multiple values at once or 
open-source and open-drain GPIOs).

koji: https://koji.fedoraproject.org/koji/taskinfo?taskID=20280065

Comment 1 Guido Aulisi 2017-07-04 09:49:28 UTC
Some informal comments:

According to this guide https://fedoraproject.org/wiki/Packaging:C_and_C%2B%2B you should add BuildRequires: gcc

You could use these macros:

make %{?_smp_mflags} => %make_build
make install DESTDIR=%{buildroot} => %make_install

The %check section is for running tests, but the docs report that 'make check' doesn't execute any tests. Instead the user must run them manually with superuser privileges. The tests work together with the gpio-mockup kernel module which must be enabled. IMHO it's very difficult to execute such a test in mock or koji, so I would suggest to remove the %check section, and the --enable-tests configure option too.

Comment 2 Vitaly 2017-07-25 10:43:12 UTC
I will review this package.

Comment 3 Vitaly 2017-07-25 10:54:53 UTC
> %setup -q

Can be replaced to %autosetup. Also you should add BuildRequires: gcc.

> make %{?_smp_mflags} V=1

Should be replaced to %make_build.

> make install DESTDIR=%{buildroot} INSTALL='install -p'

Should be replaced to %make_install.

> %check

Whole check section can be deleted as no checks can be performed in build chroot.

Comment 4 Vitaly 2017-07-25 11:07:57 UTC
> License: LGPLv2

Must be replaced to License: LGPLv2+.

Comment 5 Peter Robinson 2017-07-26 12:14:03 UTC
(In reply to Vitaly Zaitsev from comment #3)
> > %setup -q
> 
> Can be replaced to %autosetup. Also you should add BuildRequires: gcc.
> 
> > make %{?_smp_mflags} V=1
> 
> Should be replaced to %make_build.
> 
> > make install DESTDIR=%{buildroot} INSTALL='install -p'
> 
> Should be replaced to %make_install.

Do all of those work on EL7 for example? They can be replaced, but the others are generally more widely supported and it's really just superficial, it doesn't particularly provide any real benefit.

Comment 6 Peter Robinson 2017-07-26 12:14:34 UTC
(In reply to Vitaly Zaitsev from comment #4)
> > License: LGPLv2
> 
> Must be replaced to License: LGPLv2+.

Fixed locally. Anything else?

Comment 7 Vitaly 2017-07-26 13:25:25 UTC
> Do all of those work on EL7 for example?

Yes, on EPEL7 it will work fine.

> They can be replaced, but the others are generally more widely supported and it's really just superficial, it doesn't particularly provide any real benefit.

You should use more rpm macros where possible.

> Fixed locally. Anything else?

Update SPEC and SRPM and I will check it again via automated rpmreview tool.

Comment 9 Vitaly 2017-08-23 12:01:53 UTC
You should fix obsoleted m4s: AC_PROG_LIBTOOL found in: libgpiod-0.3/configure.ac:32.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- All build dependencies are listed in BuildRequires, except for any that
  are listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: gcc
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2.1)", "Unknown or generated". 4 files have unknown
     license. Detailed output of licensecheck in
     /home/vitaly/1467003-libgpiod/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== EXTRA items =====

Generic:
[!]: Package should not use obsolete m4 macros
     Note: Some obsoleted macros found, see the attachment.
     See: https://fedorahosted.org/FedoraReview/wiki/AutoTools
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libgpiod-0.3-2.fc28.x86_64.rpm
          libgpiod-utils-0.3-2.fc28.x86_64.rpm
          libgpiod-devel-0.3-2.fc28.x86_64.rpm
          libgpiod-debuginfo-0.3-2.fc28.x86_64.rpm
          libgpiod-0.3-2.fc28.src.rpm
libgpiod.x86_64: W: spelling-error Summary(en_US) linux -> Linux
libgpiod.x86_64: W: spelling-error %description -l en_US linux -> Linux
libgpiod.x86_64: W: spelling-error %description -l en_US gpiod -> period
libgpiod.x86_64: W: spelling-error %description -l en_US sysfs -> sysops
libgpiod.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
libgpiod.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
libgpiod-utils.x86_64: W: only-non-binary-in-usr-lib
libgpiod-utils.x86_64: W: no-documentation
libgpiod-utils.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
libgpiod-utils.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpiodetect
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpiofind
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpioget
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpioinfo
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpiomon
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpioset
libgpiod-devel.x86_64: W: only-non-binary-in-usr-lib
libgpiod-devel.x86_64: W: no-documentation
libgpiod.src: W: spelling-error Summary(en_US) linux -> Linux
libgpiod.src: W: spelling-error %description -l en_US linux -> Linux
libgpiod.src: W: spelling-error %description -l en_US gpiod -> period
libgpiod.src: W: spelling-error %description -l en_US sysfs -> sysops
5 packages and 0 specfiles checked; 0 errors, 22 warnings.




Rpmlint (debuginfo)
-------------------
Checking: libgpiod-utils-debuginfo-0.3-2.fc28.x86_64.rpm
          libgpiod-debuginfo-0.3-2.fc28.x86_64.rpm
libgpiod-utils-debuginfo.x86_64: E: useless-provides debuginfo(build-id)
libgpiod-utils-debuginfo.x86_64: E: debuginfo-without-sources
2 packages and 0 specfiles checked; 2 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
libgpiod.x86_64: W: spelling-error Summary(en_US) linux -> Linux
libgpiod.x86_64: W: spelling-error %description -l en_US linux -> Linux
libgpiod.x86_64: W: spelling-error %description -l en_US gpiod -> period
libgpiod.x86_64: W: spelling-error %description -l en_US sysfs -> sysops
libgpiod-utils-debuginfo.x86_64: E: useless-provides debuginfo(build-id)
libgpiod-utils-debuginfo.x86_64: E: debuginfo-without-sources
libgpiod-devel.x86_64: W: only-non-binary-in-usr-lib
libgpiod-devel.x86_64: W: no-documentation
libgpiod-utils.x86_64: W: only-non-binary-in-usr-lib
libgpiod-utils.x86_64: W: no-documentation
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpiodetect
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpiofind
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpioget
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpioinfo
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpiomon
libgpiod-utils.x86_64: W: no-manual-page-for-binary gpioset
5 packages and 0 specfiles checked; 2 errors, 14 warnings.



Requires
--------
libgpiod (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    ld-linux-x86-64.so.2()(64bit)
    libc.so.6()(64bit)
    rtld(GNU_HASH)

libgpiod-debuginfo (rpmlib, GLIBC filtered):

libgpiod-devel (rpmlib, GLIBC filtered):
    libgpiod(x86-64)
    libgpiod.so.0()(64bit)

libgpiod-utils (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libgpiod(x86-64)
    libgpiod.so.0()(64bit)
    rtld(GNU_HASH)



Provides
--------
libgpiod:
    libgpiod
    libgpiod(x86-64)
    libgpiod.so.0()(64bit)

libgpiod-debuginfo:
    debuginfo(build-id)
    libgpiod-debuginfo
    libgpiod-debuginfo(x86-64)

libgpiod-devel:
    libgpiod-devel
    libgpiod-devel(x86-64)

libgpiod-utils:
    libgpiod-utils
    libgpiod-utils(x86-64)



Source checksums
----------------
https://github.com/brgl/libgpiod/archive/v0.3.tar.gz :
  CHECKSUM(SHA256) this package     : 24794006c14194e269b944f2cca0e85e481f1538be3c143479c4c6691bf25add
  CHECKSUM(SHA256) upstream package : 24794006c14194e269b944f2cca0e85e481f1538be3c143479c4c6691bf25add


AutoTools: Obsoleted m4s found
------------------------------
  AC_PROG_LIBTOOL found in: libgpiod-0.3/configure.ac:32


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1467003 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 10 Peter Robinson 2017-08-23 12:07:04 UTC
(In reply to Vitaly Zaitsev from comment #9)
> You should fix obsoleted m4s: AC_PROG_LIBTOOL found in:
> libgpiod-0.3/configure.ac:32.

This is completely unrelated to a package review and IMO is hence irrelevant, it's something to be addressed with upstream.

> Issues:
> =======
> - All build dependencies are listed in BuildRequires, except for any that
>   are listed in the exceptions section of Packaging Guidelines.
>   Note: These BR are not needed: gcc
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

This was added at your request as per comment #3 as is now contradictory.

Comment 11 Vitaly 2017-08-23 18:02:53 UTC
> This is completely unrelated to a package review and IMO is hence irrelevant, it's something to be addressed with upstream.

This can be easily patched in %%prep:
sed -i 's/AC_PROG_LIBTOOL/LT_INIT([disable-static])/' configure.ac

Everything seems to be OK. The package is now approved.

Comment 12 Gwyn Ciesla 2017-08-23 22:23:47 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/libgpiod. You may create the branch "f27" using git in about 10 minutes.


Note You need to log in before you can comment on or make changes to this bug.